Subject: Re: Not understand some in htb_do_events function

From: Martin Devera <[email-masked]>
Date: Tue, 15 Jan 2008 12:59:38 +0100

Patrick McHardy wrote:
> Badalian Vyacheslav wrote:
>> Hello all.
>> I have many messages like "htb: too many events !" in dmesg.
>>
>> Try to see code and find that function try do 500 events at call.
>> Hm... may anyone ask why 500? Why its not dynamic value based on 
>> performance of PC?
> 
> 
> Thats a good question, I wonder why it is limited at all.
> Martin, any hints?
> 
> 

Hi, I recently replied someone to the same question:

 > it is possible when during one jiffie (1 or 10ms) more than 500 classes
 > changed its state. It is meant to protect your system from livelock.
 > The constant should be set to something like
 > bogomips/bogocomplexity_of_state_change but it was not done.

the solution I have in my mind is to change
    if (net_ratelimit())
                  printk(KERN_WARNING "htb: too many events !\n");
          return HZ/10;
  to
    return 1;

to drain extra events asap. It the time of writing I was not able to
come with better solution and there were more bugs related to this
part of code than now.
We want way to smooth big burst of events over more dequeue invocations
in order to not slow dequeue too much. Constant 500 is max. allowed
"slowdown" of dequeue.
Any bright idea how to do it more elegant, Patrick ?

brgds, devik